-------------------------------------------------------
-- 6bit ring counter
-- 2006/7/25
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity bit6ring is
	port(
		clk		:in std_logic;
		reset	:in std_logic;
		q0		:out std_logic;
		q1		:out std_logic;
		q2		:out std_logic;
		q3		:out std_logic;
		q4		:out std_logic;
		q5		:out std_logic
	);
end bit6ring;

architecture rtl of bit6ring is
	signal bufq		:std_logic_vector(5 downto 0);

begin
	process(clk,reset)
	begin
		if(reset ='0') then
			bufq <= (others => '0');
			elsif(clk' event and clk='1') then
			bufq <= bufq(4 downto 0) & not (bufq(0) or bufq(1) or bufq(2) or bufq(3) or bufq(4));
		end if;
	end process;
	
	q0 <= bufq(0);
	q1 <= bufq(1);
	q2 <= bufq(2);
	q3 <= bufq(3);
	q4 <= bufq(4);
	q5 <= bufq(5);	

end rtl;